Index: /poi/src/services/poi/AddNewVisit.java
===================================================================
--- /poi/src/services/poi/AddNewVisit.java (revision 733)
+++ /poi/src/services/poi/AddNewVisit.java (revision 753)
@@ -165,5 +165,5 @@
 				msgResponse = "callback({\"result\":\"" + result + "\"})";
 			}
-			response.setContentType("application/json;charset=ISO-8859-1");
+			response.setContentType("application/json;charset=UTF-8");
 			response.getOutputStream().print(msgResponse);
 		}
Index: /poi/src/services/poi/DeletePOI.java
===================================================================
--- /poi/src/services/poi/DeletePOI.java (revision 733)
+++ /poi/src/services/poi/DeletePOI.java (revision 753)
@@ -83,5 +83,5 @@
 				msgResponse = "callback({\"result\":\"" + result + "\"})";
 			}
-			response.setContentType("application/json;charset=ISO-8859-1");
+			response.setContentType("application/json;charset=UTF-8");
 			response.getOutputStream().print(msgResponse);
 			
Index: /poi/src/services/poi/GetPOIs.java
===================================================================
--- /poi/src/services/poi/GetPOIs.java (revision 733)
+++ /poi/src/services/poi/GetPOIs.java (revision 753)
@@ -221,5 +221,5 @@
 				
 			}
-			response.setContentType("application/json;charset=ISO-8859-1");
+			response.setContentType("application/json;charset=UTF-8");
 			response.getOutputStream().print(msgResponse);
 		}
Index: /poi/src/services/poi/UpdatePOI.java
===================================================================
--- /poi/src/services/poi/UpdatePOI.java (revision 733)
+++ /poi/src/services/poi/UpdatePOI.java (revision 753)
@@ -118,5 +118,5 @@
 			}
 			
-			response.setContentType("application/json;charset=ISO-8859-1");
+			response.setContentType("application/json;charset=UTF-8");
 			response.getOutputStream().print(msgResponse);
 		}
Index: /poi/src/services/poi/GetNN.java
===================================================================
--- /poi/src/services/poi/GetNN.java (revision 555)
+++ /poi/src/services/poi/GetNN.java (revision 753)
@@ -117,5 +117,5 @@
 				}
 			}
-			response.setContentType("application/json;charset=ISO-8859-1");
+			response.setContentType("application/json;charset=UTF-8");
 			response.getOutputStream().print(msgResponse);	
 		}
Index: /poi/src/services/poi/AddNewPOIs.java
===================================================================
--- /poi/src/services/poi/AddNewPOIs.java (revision 731)
+++ /poi/src/services/poi/AddNewPOIs.java (revision 753)
@@ -133,5 +133,5 @@
 				
 			}
-			response.setContentType("application/json;charset=ISO-8859-1");
+			response.setContentType("application/json;charset=UTF-8");
 			response.getOutputStream().print(msgResponse);
 		}
Index: /poi/src/services/poi/LogGPSTraces.java
===================================================================
--- /poi/src/services/poi/LogGPSTraces.java (revision 554)
+++ /poi/src/services/poi/LogGPSTraces.java (revision 753)
@@ -118,5 +118,5 @@
 		
 		msgResponse = "{\"result\":\"" + result + "\"}";
-		response.setContentType("application/json;charset=ISO-8859-1");
+		response.setContentType("application/json;charset=UTF-8");
 		response.getOutputStream().print(msgResponse);
 		
Index: /poi/src/services/poi/FindDuplicates.java
===================================================================
--- /poi/src/services/poi/FindDuplicates.java (revision 733)
+++ /poi/src/services/poi/FindDuplicates.java (revision 753)
@@ -112,5 +112,5 @@
 				}
 			}
-			response.setContentType("application/json;charset=ISO-8859-1");
+			response.setContentType("application/json;charset=UTF-8");
 			response.getOutputStream().print(msgResponse);
 		}
Index: /poi/build.xml
===================================================================
--- /poi/build.xml (revision 697)
+++ /poi/build.xml (revision 753)
@@ -2,5 +2,5 @@
 <project name="poi" default="jar">
 	
-	<property name="remote" 		value="root@snf-97398.vm.okeanos.grnet.gr"/>
+	<property name="remote" 		value="root@83.212.104.253"/>
 	<property name="app.name" 		value="poi"/>		
 	<property name="war" 			value="${app.name}.war"/>